• 关于

    exit

    的搜索结果

回答

sys.exit(n) 退出程序引发SystemExit异常,可以捕获异常执行些清理工作。n默认值为0,表示正常退出,其他都是非正常退出。还可以sys.exit(“sorry, goodbye!”); 一般主程序中使用此退出。os._exit(n), 直接退出, 不抛异常, 不执行相关清理工作。常用在子进程的退出。exit()/quit(),跑出SystemExit异常。一般在交互式shell中退出时使用。exit(0) 有什么功能? 在很多类型的操作系统里,exit(0) 可以中断某个程序,而其中的数字参数则用来表示程序是否是碰到错误而中断。exit(1) 表示发生了错误,而 exit(0) 则表示程序是正常退出的。这和我们学的布尔逻辑 0==False 正好相反,不过你可以用不一样的数字表示不同的错误结果。比如你可以用exit(100) 来表示另一种和 exit(2)或 exit(1) 不同的错误。

元芳啊 2019-12-02 01:04:30 0 浏览量 回答数 0

回答

return与exit的区别是什么?exit()是一个函数,结束一个进程,它将删除进程使用的内存空间,同时把错误信息返回父进程,在父进程中wait系统调用将接受到此返回信息。return返回函数值,是关键字在main函数中我们通常使用return (0);这样的方式返回一个值。但这是限定在非void情况下的也就是void main()这样的形式。exit()通常是用在子程序中用来终结程序用的,使用后程序自动结束跳会操作系统。但在如果把exit用在main内的时候无论main是否定义成void返回的值都是有效的,并且exit不需要考虑类型,exit(1)等价于return (1)exit(0); //正常退出非0即是非正常退出数字0,1,-1会被写入环境变量ERRORLEVEL,其它程序可以由此判断程序结束状态。一般0为正常推出,其它数字为异常,其对应的错误可以自己指定。

a123456678 2019-12-02 02:02:09 0 浏览量 回答数 0

问题

我在跑spark的时候(一次提交20个job),遇到这样一个错误

hbase小能手 2019-12-01 19:40:30 380 浏览量 回答数 1

阿里云试用中心,为您提供0门槛上云实践机会!

0元试用32+款产品,最高免费12个月!拨打95187-1,咨询专业上云建议!

回答

一个上下文管理器的类,最起码要定义__enter__和__exit__方法。 让我们来构造我们自己的开启文件的上下文管理器,并学习下基础知识。 class File(object): def __init__(self, file_name, method): self.file_obj = open(file_name, method) def __enter__(self): return self.file_obj def __exit__(self, type, value, traceback): self.file_obj.close() 通过定义__enter__和__exit__方法,我们可以在with语句里使用它。我们来试试: with File('demo.txt', 'w') as opened_file: opened_file.write('Hola!') 我们的__exit__函数接受三个参数。这些参数对于每个上下文管理器类中的__exit__方法都是必须的。我们来谈谈在底层都发生了什么。 with语句先暂存了File类的__exit__方法然后它调用File类的__enter__方法__enter__方法打开文件并返回给with语句打开的文件句柄被传递给opened_file参数我们使用.write()来写文件with语句调用之前暂存的__exit__方法__exit__方法关闭了文件

montos 2020-04-16 21:44:28 0 浏览量 回答数 0

回答

我们还没有谈到__exit__方法的这三个参数:type, value和traceback。 在第4步和第6步之间,如果发生异常,Python会将异常的type,value和traceback传递给__exit__方法。 它让__exit__方法来决定如何关闭文件以及是否需要其他步骤。在我们的案例中,我们并没有注意它们。 那如果我们的文件对象抛出一个异常呢?万一我们尝试访问文件对象的一个不支持的方法。举个例子: with File('demo.txt', 'w') as opened_file: opened_file.undefined_function('Hola!') 我们来列一下,当异常发生时,with语句会采取哪些步骤。 1. 它把异常的type,value和traceback传递给__exit__方法 2. 它让__exit__方法来处理异常 3. 如果__exit__返回的是True,那么这个异常就被优雅地处理了。 4. 如果__exit__返回的是True以外的任何东西,那么这个异常将被with语句抛出。 在我们的案例中,__exit__方法返回的是None(如果没有return语句那么方法会返回None)。因此,with语句抛出了那个异常。 Traceback (most recent call last): File "<stdin>", line 2, in <module> AttributeError: 'file' object has no attribute 'undefined_function' 我们尝试下在__exit__方法中处理异常: class File(object): def __init__(self, file_name, method): self.file_obj = open(file_name, method) def __enter__(self): return self.file_obj def __exit__(self, type, value, traceback): print("Exception has been handled") self.file_obj.close() return True with File('demo.txt', 'w') as opened_file: opened_file.undefined_function() # Output: Exception has been handled 我们的__exit__方法返回了True,因此没有异常会被with语句抛出。 这还不是实现上下文管理器的唯一方式。还有一种方式,我们会在下一节中一起看看。

montos 2020-04-16 21:46:01 0 浏览量 回答数 0

回答

a=1234567890123456789012345678901234567890123456789012345678901b=1234567890123456789012345678901234567890123456789012345678902 function lower_than() { python -c "import sys; sys.exit(0) if $1 < $2 else sys.exit(1)" } function great_than() { python -c "import sys; sys.exit(0) if $1 > $2 else sys.exit(1)" } lower_than $a $b && echo "$a < $b" great_than $a $b && echo "$a > $b"

a123456678 2019-12-02 02:56:23 0 浏览量 回答数 0

问题

Java多线程中关于join的问题? 探究 总结报错

因为相信,所以看见。 2020-05-27 10:02:10 7 浏览量 回答数 1

问题

Windows Phone 7 - 如何退出程序:报错

kun坤 2020-06-20 11:52:16 1 浏览量 回答数 1

回答

//顺序表的插入 void Insert(int i, int item) { if (length >= MaxSize) { cerr << "上溢"; exit(1); } if (i<1 || i>length + 1) { cerr << "插入位置非法"; exit(1); } for (int j = length; j >= i - 1; j--) data[j + 1] = data[j]; data[i - 1] = item; length++; } //顺序表的删除 int Delete(int i) { if (length == 0) { cerr << "下溢"; exit(1); } if (i<1 || i>length) { cerr << "删除位置非法"; exit(1); } int x = data[i - 1]; for (int j = i; j < length; j++) data[j - 1] = data[j]; length--; return x; } //入栈操作 void Push(T x) { if (top == MaxSize - 1) { cerr << "上溢"; exit(1); } top++; data[top] = x; } //出栈操作 int Pop() { if (top == -1) { cerr << "下溢"; exit(1); } int x = data[top--]; return x; }

沉默术士 2019-12-02 01:22:39 0 浏览量 回答数 0

问题

Python中的基本测试框架

祖安文状元 2020-02-22 18:28:48 15 浏览量 回答数 2

问题

求教关于一个工具栏的问题

爵霸 2019-12-01 19:43:41 861 浏览量 回答数 1

回答

常用方法: 1、 通过sys模块获取程序参数 import sys def usage(): '''usage''' print 'Usage: %s %s %s %s' % (sys.argv[0], 'tokenid', 'Subject', 'Content') sys.exit() def main(): if len(sys.argv) != 4: usage() else: print(sys.argv[0]) print(sys.argv[1]) print(sys.argv[2]) print(sys.argv[3]) if name == "__main__": main() 运行脚本: D:Pythonmodules>python os_modules.pyUsage: os_modules.py tokenid Subject Content D:Pythonmodules>python os_modules.py aa bb ccos_modules.pyaabbccpython的sys模块默认是把第一个参数默认是程序本省,从第二个参数起都是代码后面跟着的参数,通过sys.arg[n]就可以获得传入到程序中的参数\ sys.stdinstdoutstderr 功能:stdin , stdout , 以及stderr 变量包含与标准I/O 流对应的流对象. 如果需要更好地控制输出,而print 不能满足你的要求, 它们就是你所需要的. 你也可以替换它们, 这时候你就可以重定向输出和输入到其它设备( device ), 或者以非标准的方式处理它们 sys.stdout 与print 当我们在 Python 中打印对象调用 print obj 时候,事实上是调用了sys.stdout.write(obj+'n'),print 将你需要的内容打印到了控制台,然后追加了一个换行符,print 会调用 sys.stdout 的 write 方法 以下两行在事实上等价 import syssys.stdout.write("hello")print('hello') hellohello import syssys.stdout.write("hello n")print('hello') hello hello sys.stdin 与 raw_input import sysa = raw_input('raw_input_name: ')print(a)print 'stdin_name: ',b = sys.stdin.readline()print(b) raw_input_name: ;LIJUNJIANG ;LIJUNJIANG stdin_name: AAAA AAAA 从控制台重定向到文件 Import sysf_handler=open('out.log', 'w')sys.stdout=f_handlerprint 'hello' 在当前文件下新生成一个文件out.log,文件内容为hello, 捕获sys.exit(n)调用 功能:执行到主程序末尾,解释器自动退出,但是如果需要中途退出程序,可以调用sys.exit函数,带有一个可选的整数参数返回给调用它的程序,表示你可以在主程序中捕获对sys.exit的调用。(0是正常退出,其他为异常) def exitfunc(): print "hello world" sys.exitfunc = exitfunc # 设置捕获时调用的函数print "This exit test"sys.exit(1) # 退出自动调用exitfunc()后,程序依然退出了print "there" # 不会被 print结果:This exit testhello world exitfunc()函数,及当执行sys.exit(1)的时候,调用exitfunc()函数 sys.exit(1)后面的内容就不会执行了,因为程序已经退出

xuning715 2019-12-02 01:10:13 0 浏览量 回答数 0

问题

哪位好心人看一下这是什么进程,在做啥

杨冬芳 2019-12-01 20:22:18 1298 浏览量 回答数 1

回答

我找到了一种方法:使用一个指示程序名称的变量 global prog_name = "mytest"; probe kernel.function("do_exit").call { if(execname() == progname){ printf("called kernel/exit.c: do_exit\n"); } }

游客ufivfoddcd53c 2020-01-04 15:00:50 0 浏览量 回答数 0

回答

最好避免使用 which,做为一个外部的工具,并不一定存在,在发行版之间也会有区别,有的系统的 which 命令不会设置有效的 exit status,存在一定的不确定性。 Bash 有提供一些内建命令如 hash、type、command 也能达到要求。 $ command -v foo >/dev/null 2>&1 || { echo >&2 "I require foo but it's not installed. Aborting."; exit 1; } $ type foo >/dev/null 2>&1 || { echo >&2 "I require foo but it's not installed. Aborting."; exit 1; } $ hash foo 2>/dev/null || { echo >&2 "I require foo but it's not installed. Aborting."; exit 1; }

a123456678 2019-12-02 02:50:50 0 浏览量 回答数 0

问题

关于waitpid函数的一个问题

杨冬芳 2019-12-01 19:33:47 826 浏览量 回答数 1

问题

用socket写了个linux聊天的小程序,一客户端一直输出接受消息成功 ==

小旋风柴进 2019-12-01 19:41:51 895 浏览量 回答数 1

问题

Berkeley DB: 在c api调用中异常退出导致卡在 futex_wait 调用

a123456678 2019-12-01 20:02:16 1134 浏览量 回答数 2

问题

python怎么用exit

云计算小粉 2019-12-01 19:58:12 479 浏览量 回答数 2

问题

python exit 怎么用

云计算小粉 2019-12-01 20:04:18 393 浏览量 回答数 2

问题

android6.0.1源码编译报错如下,求教~~~?报错

爱吃鱼的程序员 2020-06-10 15:25:33 0 浏览量 回答数 1

问题

新手求助,linux bash输exit后卡住

杨冬芳 2019-12-01 20:23:22 1040 浏览量 回答数 1

问题

hadoop mr Task process exit with nonzero status of 134

封神 2019-12-01 19:51:35 1116 浏览量 回答数 1

问题

postgresql 日志报错 FATAL: out of on_proc_exit slots

擎雨 2019-12-01 19:30:42 1184 浏览量 回答数 0

回答

python的程序有两种退出方式:os._exit(), sys.exit()。

世事皆空 2019-12-02 01:07:00 0 浏览量 回答数 0

回答

程序运行结束都有个exit code的吧 把exit code存入变量,if语句检测变量值是否为0。

落地花开啦 2019-12-02 01:46:52 0 浏览量 回答数 0

问题

该标志如何工作?

kun坤 2019-12-01 22:06:43 3 浏览量 回答数 1

问题

Process finished with exit code -1073741510?报错

爱吃鱼的程序员 2020-06-22 18:30:17 0 浏览量 回答数 1

回答

system->crt->main() void crt() { main(); exit(); } //上面是内部实现的,下面是你写的代码。你生成的汇编代码只是下面的。 void main() { return; }######返回出去?表示我也不知道,同求######CRT里有eixt(). int main() { return 0; } 一路F11运行,你就看见了.vc6下有: 00401129 add esp,0Ch 0040112C mov dword ptr [mainret],eax 0040112F mov edx,dword ptr [mainret] 00401132 push edx 00401133 call exit (00401210) $L17377: 00401138 mov eax,dword ptr [ebp-14h] 0040113B mov ecx,dword ptr [eax] 0040113D mov edx,dword ptr [ecx] 0040113F mov dword ptr [ebp-20h],edx 00401142 mov eax,dword ptr [ebp-14h] 00401145 push eax 00401146 mov ecx,dword ptr [ebp-20h] 00401149 push ecx 0040114A call _XcptFilter (004013a0) 0040114F add esp,8 $L17379: 00401152 ret $L17378: 00401153 mov esp,dword ptr [ebp-18h] 00401156 mov edx,dword ptr [ebp-20h] 00401159 push edx 0040115A call _exit (00401230) 看见call _exit了吧.###### 引用来自“周翼翼”的答案 CRT里有eixt(). int main() { return 0; } 一路F11运行,你就看见了.vc6下有: 00401129 add esp,0Ch 0040112C mov dword ptr [mainret],eax 0040112F mov edx,dword ptr [mainret] 00401132 push edx 00401133 call exit (00401210) $L17377: 00401138 mov eax,dword ptr [ebp-14h] 0040113B mov ecx,dword ptr [eax] 0040113D mov edx,dword ptr [ecx] 0040113F mov dword ptr [ebp-20h],edx 00401142 mov eax,dword ptr [ebp-14h] 00401145 push eax 00401146 mov ecx,dword ptr [ebp-20h] 00401149 push ecx 0040114A call _XcptFilter (004013a0) 0040114F add esp,8 $L17379: 00401152 ret $L17378: 00401153 mov esp,dword ptr [ebp-18h] 00401156 mov edx,dword ptr [ebp-20h] 00401159 push edx 0040115A call _exit (00401230) 看见call _exit了吧. .file "t.c" .text .globl main .type main, @function main: .LFB0: .cfi_startproc pushq %rbp .cfi_def_cfa_offset 16 .cfi_offset 6, -16 movq %rsp, %rbp .cfi_def_cfa_register 6 movl %edi, -4(%rbp) movq %rsi, -16(%rbp) movl $0, %eax popq %rbp .cfi_def_cfa 7, 8 ret .cfi_endproc .LFE0: .size main, .-main .ident "GCC: (Ubuntu/Linaro 4.6.3-1ubuntu5) 4.6.3" .section .note.GNU-stack,"",@progbits 表示gcc下这个文件 的汇编文件如上,根本没有 exit 的调用。额…… ######在CRT里.######应该是在CRT里面######楼主找几篇执行文件的组成的文章看看就知道了。 ######在crt动态库里,不在程序里

kun坤 2020-05-29 17:20:54 0 浏览量 回答数 0

回答

1.在终端输入python,进入之后退出:quit()1或者exit()12,进入idle shell下的退出 关闭:quit()1或者exit()1或者快捷键Ctrl+d

ylrf1212 2019-12-02 01:08:58 0 浏览量 回答数 0
阿里云大学 云服务器ECS com域名 网站域名whois查询 开发者平台 小程序定制 小程序开发 国内短信套餐包 开发者技术与产品 云数据库 图像识别 开发者问答 阿里云建站 阿里云备案 云市场 万网 阿里云帮助文档 免费套餐 开发者工具 企业信息查询 小程序开发制作 视频内容分析 企业网站制作 视频集锦 代理记账服务 2020阿里巴巴研发效能峰会 企业建站模板 云效成长地图 高端建站